<?
  // VStarBlogEngine - admin.php
  // (C) 2008-2009 Vladislav Staroselskiy (inet@vladstar.com)

  require "init.inc";

  $table=isset($_REQUEST["table"])&&$_REQUEST["table"]?unescape(urldecode($_REQUEST["table"])):false;
  $action=isset($_REQUEST["action"])&&$_REQUEST["action"]?unescape(urldecode($_REQUEST["action"])):false;
  $orderby=isset($_REQUEST["orderby"])&&$_REQUEST["orderby"]?unescape(urldecode($_REQUEST["orderby"])):false;
  $id=isset($_REQUEST["id"])&&is_numeric($_REQUEST["id"])&&$_REQUEST["id"]>0?$_REQUEST["id"]:false;
  $page=isset($_REQUEST["page"])&&is_numeric($_REQUEST["page"])&&$_REQUEST["page"]>=0?$_REQUEST["page"]:0;
  $reverse=isset($_REQUEST["reverse"])&&is_numeric($_REQUEST["reverse"])&&$_REQUEST["reverse"]>0?$_REQUEST["reverse"]:false;
  $syncdate=isset($_REQUEST["syncdate"])&&$_REQUEST["syncdate"]?unescape(urldecode($_REQUEST["syncdate"])):"1970-00-00 00:00:00";

  $title=BLOG_ADMIN_TITLE;
  $content="";

  // Construct dependencies between tables
  $linked=array();
  $linked[BLOG_POSTS_TABLE][BLOG_POSTS_TABLE_USER_ID]=array(BLOG_USERS_TABLE,BLOG_USERS_TABLE_ID,"CONCAT(".BLOG_USERS_TABLE_NAME.",' (',".BLOG_USERS_TABLE_LOGIN.",')')","Name");
  $linked[BLOG_COMMENTS_TABLE][BLOG_COMMENTS_TABLE_POST_ID]=array(BLOG_POSTS_TABLE,BLOG_POSTS_TABLE_ID,"CONCAT(".BLOG_POSTS_TABLE_DATETIME.",' ',".BLOG_POSTS_TABLE_TITLE.",' (',".BLOG_POSTS_TABLE_ID.",') ')","Post");
// $linked[BLOG_COMMENTS_TABLE][BLOG_COMMENTS_TABLE_PARENT_ID]=array(BLOG_COMMENTS_TABLE,BLOG_COMMENTS_TABLE_ID,"CONCAT(".BLOG_COMMENTS_TABLE_DATETIME.",' ',".BLOG_COMMENTS_TABLE_AUTHOR.",' (',".BLOG_COMMENTS_TABLE_EMAIL.",')')","ParentComment");

  if ($userid && $userstatus>=BLOG_USERS_TABLE_USER_STATUS_ADMIN) {
    $tabnames=$blog->table_names();
    if ($table) {
      foreach($tabnames as $tabname) {
        if ($table==$tabname["table_name"]) break;
      }
      if ($table==$tabname["table_name"]) {
        $title="Table '".$table."'";
        if ($table==BLOG_POSTS_TABLE) $fname_id=BLOG_POSTS_TABLE_ID;
        elseif ($table==BLOG_COMMENTS_TABLE) $fname_id=BLOG_COMMENTS_TABLE_ID;
        elseif ($table==BLOG_TAGS_TABLE) $fname_id=BLOG_TAGS_TABLE_ID;
        elseif ($table==BLOG_SPAMFILTERS_TABLE) $fname_id=BLOG_SPAMFILTERS_TABLE_ID;
        elseif ($table==BLOG_USERS_TABLE) $fname_id=BLOG_USERS_TABLE_ID;
      }
      if ($table==$tabname["table_name"] && $_SERVER["REQUEST_METHOD"]=="GET") {
        if ($action=="killspam") {
          $blog->query("UPDATE ".BLOG_COMMENTS_TABLE.",".BLOG_COMMENTS_TABLE." AS CommentsSpam SET ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_PARENT_ID."='0' WHERE ".BLOG_COMMENTS_TABLE.".".BLOG_COMMENTS_TABLE_PARENT_ID."=CommentsSpam.".BLOG_COMMENTS_TABLE_ID." AND CommentsSpam.".BLOG_COMMENTS_TABLE_STATUS."='".BLOG_COMMENTS_TABLE_STATUS_SPAM."'");
          $blog->query("DELETE FROM ".BLOG_COMMENTS_TABLE." WHERE ".BLOG_COMMENTS_TABLE_STATUS."='".BLOG_COMMENTS_TABLE_STATUS_SPAM."'");
          header('location: '.$_SERVER["HTTP_REFERER"]);
        } elseif ($action=="killtags") {
          $blog->query("DELETE FROM ".BLOG_TAGS_TABLE." WHERE ".BLOG_TAGS_TABLE_ID." IN (SELECT ID FROM (SELECT Tags1.".BLOG_TAGS_TABLE_ID." FROM ".BLOG_TAGS_TABLE." AS Tags1 LEFT JOIN ".BLOG_TAGS2POSTS_TABLE." ON Tags1.".BLOG_TAGS_TABLE_ID."=".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_TAG_ID." GROUP BY Tags1.".BLOG_TAGS_TABLE_ID." HAVING COUNT(".BLOG_TAGS2POSTS_TABLE.".".BLOG_TAGS2POSTS_TABLE_POST_ID.")='0') AS Tags2)");
          header('location: '.$_SERVER["HTTP_REFERER"]);
        } elseif ($action=="syncposts") {
          $content=SyncPosts($syncdate);
        } elseif (! $action) {
          $content=ShowAdminList("blog_admin",$table,BLOG_ADMIN_ROWS_LIMIT,$page,$orderby,$reverse);
        } elseif ($action=="add") {
          if ($table==BLOG_POSTS_TABLE) $title.=" - ".BLOG_ADMIN_POST_ADD; else $title.=" - ".BLOG_ADMIN_ADD_RECORD;
          $content=ShowAdminForm("post",$table,$action,$id);
        } elseif ($action=="edit" && $id) {
          if ($table==BLOG_POSTS_TABLE) $title.=" - ".BLOG_ADMIN_POST_EDIT; else $title.=" - ".BLOG_ADMIN_EDIT_RECORD;
          $content=ShowAdminForm("post",$table,$action,$id);
        } elseif ($action=="delete" && $id) {
          if ($table==BLOG_POSTS_TABLE) $title.=" - ".BLOG_ADMIN_POST_DELETE; else $title.=" - ".BLOG_ADMIN_DELETE_RECORD;
          $content=ShowAdminForm("post",$table,$action,$id);
        }
      } elseif ($table==$tabname["table_name"] && $_SERVER["REQUEST_METHOD"]=="POST") {

        if ($action=="delete" && $id) {
          if ($table==BLOG_POSTS_TABLE) {
            if (defined('BLOG_LJ_ENABLE_CROSSPOST') && BLOG_LJ_ENABLE_CROSSPOST && $userljname && $userljpass && $lj_itemid=get_value("SELECT ".BLOG_POSTS_TABLE_LJ." FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE_ID."='".$id."' LIMIT 1")) {
              list($headers,$lines,$retvalues)=LJUpdate($userljname, $userljpass, $userljname, $lj_itemid ,'', '');
            }
            $query="DELETE FROM ".BLOG_TAGS2POSTS_TABLE." WHERE ".BLOG_TAGS2POSTS_TABLE_POST_ID."='".$id."'";
            $blog->query($query);
          }
          $query="DELETE FROM ".$table." WHERE ".$table.".ID='".$id."' LIMIT 1";
          $blog->query($query);
          header("location: ".params(false, false, false, false, false, false, $table, $orderby, $reverse));
        } elseif ($action=="add") {
          $blog->query("SELECT * FROM ".$table." LIMIT 1");
          $blog->next_record();
          $fnames=$blog->field_names();
          $f=$v="";
          foreach($fnames as $fname) {
            if ($fname=="CreatedOn") $_POST[$fname]=date("Y-m-d H:i:s");
            if ($table==BLOG_POSTS_TABLE && $fname=="User_ID" && ! isset($_POST[$fname])) $_POST[$fname]=$userid;
            if ($table==BLOG_USERS_TABLE && $fname==BLOG_USERS_TABLE_PASS && isset($_POST[$fname])) {
              if (trim($_POST[$fname])=="") unset($_POST[$fname]);
              elseif (strlen($_POST[$fname])<32) $_POST[$fname]=md5(unescape($_POST[$fname]));
            }
            if ($fname!=$fname_id && isset($_POST[$fname]) && $_POST[$fname]) {
              if ($f) $f.=",";
              if ($v) $v.=",";
              $f.=$fname;
              $v.="'".escape($_POST[$fname])."'";
            }
          }
          $blog->query("INSERT INTO ".$table." (".$f.") VALUES (".$v.");");
          if ($table==BLOG_POSTS_TABLE) {
            $post_id=$blog->insert_id();
            if (isset($_POST["Tags"]) && trim($_POST["Tags"])) SaveTags($post_id,explode(",",trim(unescape($_POST["Tags"]))));
            if (defined('BLOG_LJ_ENABLE_CROSSPOST') && BLOG_LJ_ENABLE_CROSSPOST && $userljname && $userljpass) {
              $msg_tail="";
              if (isset($_POST["Add_LJ_footer"]) && $_POST["Add_LJ_footer"]) {
                $msg_tail="<p align=\"right\"><b><a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$post_id."\" align=\"right\" class=\"comments\"><img src=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/comments.php?post=".$post_id."\" border=0 width=8 height=12>".BLOG_LJ_COMMENTS."</a></b>|<a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$post_id."#reply\">".BLOG_LJ_LEAVE_COMMENT."</a></p>";
              }
              list($headers,$lines,$retvalues)=LJAdd($userljname, $userljpass, $userljjournal, unescape($_POST[BLOG_POSTS_TABLE_TITLE]), unescape($_POST[BLOG_POSTS_TABLE_CONTENT]).$msg_tail, ($_POST[BLOG_POSTS_TABLE_POST_STATUS]==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE?"private":($_POST[BLOG_POSTS_TABLE_POST_STATUS]==BLOG_POSTS_TABLE_POST_STATUS_FRIENDS?"usemask":"public")), unescape($_POST["Tags"]), (isset($_POST["Allow_LJ_Comments"])&&$_POST["Allow_LJ_Comments"]?0:1));
              if ($retvalues["success"]=="OK") {
                $blog->query("UPDATE ".BLOG_POSTS_TABLE." SET ".BLOG_POSTS_TABLE_LJ."='".addslashes($retvalues["itemid"])."',".BLOG_POSTS_TABLE_LJ_URL."='".addslashes($retvalues["url"])."' WHERE ".BLOG_POSTS_TABLE_ID."='".$post_id."' LIMIT 1");
              }
            }
          }
          header("location: ".params(false, false, false, false, false, false, $table, $orderby, $reverse));
        } elseif ($action=="edit") {
          if ($table==BLOG_POSTS_TABLE) {
            $blog->query("DELETE FROM ".BLOG_TAGS2POSTS_TABLE." WHERE ".BLOG_TAGS2POSTS_TABLE_POST_ID."='".$id."'");
            if (isset($_POST["Tags"]) && $_POST["Tags"]) SaveTags($id,explode(",",trim(unescape($_POST["Tags"]))));
          }
          $blog->query("SELECT * FROM ".$table." LIMIT 1");
          $blog->next_record();
          $fnames=$blog->field_names();
          $v="";
          foreach($fnames as $fname) {
            if ($fname=="CreatedOn" && ! isset($_POST[$fname])) $_POST[$fname]=date("Y-m-d H:i:s");
            if ($table==BLOG_POSTS_TABLE && $fname=="User_ID" && ! isset($_POST[$fname])) $_POST[$fname]=$userid;
            if ($table==BLOG_USERS_TABLE && $fname==BLOG_USERS_TABLE_PASS && isset($_POST[$fname])) {
              if (trim($_POST[$fname])=="") unset($_POST[$fname]);
              elseif (strlen($_POST[$fname])<32) $_POST[$fname]=md5(unescape($_POST[$fname]));
            }
            if ($fname!=$fname_id && isset($_POST[$fname]) && $_POST[$fname]) {
              if ($v) $v.=",";
              $v.=$fname."='".escape($_POST[$fname])."'";
            }
          }
          $blog->query("UPDATE ".$table." SET ".$v." WHERE ID='".$id."'");
          if ($table==BLOG_POSTS_TABLE && defined('BLOG_LJ_ENABLE_CROSSPOST') && BLOG_LJ_ENABLE_CROSSPOST && $userljname && $userljpass) {
            $post_id=$id;
            $msg_tail="";
            if (isset($_POST["Add_LJ_footer"]) && $_POST["Add_LJ_footer"]) {
              $msg_tail="<p align=\"right\"><b><a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$post_id."\" align=\"right\" class=\"comments\"><img src=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/comments.php?post=".$post_id."\" border=0 width=8 height=12>".BLOG_LJ_COMMENTS."</a></b>|<a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$post_id."#reply\">".BLOG_LJ_LEAVE_COMMENT."</a></p>";
            }
            if ($lj_itemid=get_value("SELECT ".BLOG_POSTS_TABLE_LJ." FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE_ID."='".$post_id."' LIMIT 1")) {
              // Update LJ post
              list($headers,$lines,$retvalues)=LJUpdate($userljname, $userljpass, $userljjournal, $lj_itemid ,unescape($_POST[BLOG_POSTS_TABLE_TITLE]), unescape($_POST[BLOG_POSTS_TABLE_CONTENT]).$msg_tail, ($_POST[BLOG_POSTS_TABLE_POST_STATUS]==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE?"private":($_POST[BLOG_POSTS_TABLE_POST_STATUS]==BLOG_POSTS_TABLE_POST_STATUS_FRIENDS?"usemask":"public")), unescape($_POST["Tags"]), (isset($_POST["Allow_LJ_Comments"])&&$_POST["Allow_LJ_Comments"]?0:1));
            } else {
              // LJ post does not exist, add a new one
              list($headers,$lines,$retvalues)=LJAdd($userljname, $userljpass, $userljjournal, unescape($_POST[BLOG_POSTS_TABLE_TITLE]), unescape($_POST[BLOG_POSTS_TABLE_CONTENT]).$msg_tail, ($_POST[BLOG_POSTS_TABLE_POST_STATUS]==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE?"private":($_POST[BLOG_POSTS_TABLE_POST_STATUS]==BLOG_POSTS_TABLE_POST_STATUS_FRIENDS?"usemask":"public")), unescape($_POST["Tags"]), (isset($_POST["Allow_LJ_Comments"])&&$_POST["Allow_LJ_Comments"]?0:1));
              if ($retvalues["success"]=="OK") {
                $blog->query("UPDATE ".BLOG_POSTS_TABLE." SET ".BLOG_POSTS_TABLE_LJ."='".addslashes($retvalues["itemid"])."',".BLOG_POSTS_TABLE_LJ_URL."='".addslashes($retvalues["url"])."' WHERE ".BLOG_POSTS_TABLE_ID."='".$post_id."' LIMIT 1");
              }
            }
          }
          header("location: ".params(false, false, false, false, false, false, $table, $orderby, $reverse));
        }
      } else {
        $content = BLOG_MESSAGE_ADMIN_NO_TABLE;
      }
    } else {
      $content.="<table class=\"blog_ext\"><tr class=\"blog_admin\"><td class=\"blog_admin\"><h5>".BLOG_ADMIN_ACTIONS.":</h5><ul>\n";
      $content.="<li><a class=\"blog_admin\" href=\"?table=".BLOG_COMMENTS_TABLE."&action=killspam\">".BLOG_ADMIN_KILL_SPAM."</a></li>";
      $content.="<li><a class=\"blog_admin\" href=\"?table=".BLOG_TAGS_TABLE."&action=killtags\">".BLOG_ADMIN_DELETE_UNUSED_TAGS."</a></li>";
      $content.=(BLOG_LJ_ENABLE_CROSSPOST&&$userljname&&$userljpass?"<li><a class=\"blog_admin\" href=\"sync.php\">".BLOG_LJ_SYNC_TITLE."</a></li>":"");
      $content.=(BLOG_LJ_ENABLE_CROSSPOST&&$userljname&&$userljpass&&function_exists('xml_parser_create')?"<li><a class=\"blog_admin\" href=\"sync_comments.php\">".BLOG_LJ_SYNC_COMMENTS_TITLE."</a></li>":"");
      $content.="</ul><h5>".BLOG_ADMIN_TABLE_MANAGEMENT.":</h5><ul>\n";
      foreach($tabnames as $tabname) {
        if (array_search($tabname["table_name"],array(BLOG_TAGS2POSTS_TABLE,BLOG_LJ_SYNC_POSTS_TABLE,BLOG_LJ_SYNC_COMMENTS_TABLE,BLOG_LJ_SYNC_COMMENTS_METADATA_TABLE,BLOG_LJ_SYNC_COMMENTS_USERMAPS_TABLE))===false) {
          $content.="<li><a class=\"blog_admin\" href=\"?table=".$tabname["table_name"]."\">".$tabname["table_name"]."</a></li>";
        }
      }
      $content.="</ul>\n";
    }
    if (isset($retvalues["errmsg"]) && isset($retvalues["success"]) && $retvalues["success"]=="FAIL") {
      $message.=BLOG_LJ_ERROR." \"".$retvalues["errmsg"]."\"";
    }
?>


<html lang="<?=BLOG_LANGUAGE?>">
<head>
  <title><?=$_SERVER["SERVER_NAME"]." - ".($title?$title:BLOG_MAIN_TITLE)?></title>
<?
  include "head.inc";
?>
</head>
<body>
<?
  @include "html_top.inc";
?>
<table class="blog_ext"><tr class="blog_ext"><td class="blog_ext">
<?
  print "<h1 class=\"blog_title\"><a class=\"blog_title\" href=\"./\">".BLOG_MAIN_TITLE."</a></h1>\n";

  print ShowLoginForm("blog_login");
  if (! isset($post_id) || ! $post_id) print "<h3 class=\"blog\">".$title."</h3>\n";

  if (isset($messageok) && $messageok) print "<p class=\"messageok\">".$messageok."</p>\n";
  if (isset($message) && $message) print "<p class=\"message\">".$message."</p>\n";
  print $content;
?>
</td></tr>
<tr class="copyright"><td colspan=2 class="copyright">
Powered by <a href="http://vladstar.com/">VStarBlogEngine</a> (C) 2008-2009 Vladislav Staroselskiy
</td></tr>
</table>

<?
  @include "html_bottom.inc";
?>

</body>
</html>
<?
  } else {
    die(BLOG_MESSAGE_ACCESS_DENIED);
  }
?>